<template>
  <div class="flex flex-col h-full">
    <PageHeader
      show-search
      :loading="isLoading"
      @refresh="onPageRefresh"
      @search="value => term = value"
    />

    <Viewport
      :loading="isPaginationLoading"
      @fully-scrolled="onFullyScrolled"
    >
      <GuestsListSkeleton v-if="isLoading" />
      <EmptyState v-else-if="!isLoading && !guestsStore.guests.length" />

      <Container
        v-if="!isLoading || guestsStore.guests.length"
        class="!p-0 mt-2"
      >
        <v-scroll-y-transition group>
          <section
            v-for="guest in guestsStore.guests"
            :key="guest.id"
            class="p-4 lg:p-8 border-b-[1px] border-b-gray-300 last:border-b-0"
          >
            <section class="block lg:flex">
              <section class="flex items-center flex-auto">
                <TextAvatar :value="guest.name" />

                <section class="ml-3 max-w-[90%]">
                  <span class="text-lg font-lighter">
                    {{ guest.name }}
                  </span>

                  <section class="flex items-end text-sm text-gray-500">
                    <v-icon icon="mdi-music-accidental-sharp" />
                    <span>{{ String(guest.id).padStart(4, '0') }}</span>
                  </section>
                </section>
              </section>

              <section class="flex items-center justify-start lg:justify-center pt-4 lg:pt-0">
                <v-btn
                  text="Подробнее"
                  variant="outlined"
                  class="text-teal-600 border-teal-600"
                  append-icon="mdi-open-in-new"
                  rounded
                  @click="$router.push(`/guests/${guest.id}`)"
                />
              </section>
            </section>
          </section>
        </v-scroll-y-transition>
      </Container>
    </Viewport>
  </div>

  <CreateGuestForm />
</template>

<script setup lang="ts">
import { onMounted, ref, watch } from 'vue';

import { GUESTS_PAGE_SIZE } from '@/declarations';
import { usePagination } from '@/composables';
import { useGuestsStore } from '@/stores';

import Viewport from '@/components/layout/Viewport.vue';
import PageHeader from '@/components/layout/PageHeader.vue';
import EmptyState from '@/components/layout/EmptyState.vue';
import Container from '@/components/layout/Container.vue';
import TextAvatar from '@/components/content/TextAvatar.vue';

import GuestsListSkeleton from '@/components/skeletons/GuestsListSkeleton.vue';
import CreateGuestForm from './CreateGuestForm.vue';

const pagination = usePagination({ size: GUESTS_PAGE_SIZE });

const guestsStore = useGuestsStore();

const isLoading = ref(true);
const isPaginationLoading = ref(false);
const term = ref('');

const fetchData = async (options: Partial<PageFetchDataOptions>) => {
  if (options.useLoading) {
    isLoading.value = true;
  }

  await guestsStore.fetchData({
    reset: options.reset,
    limit: GUESTS_PAGE_SIZE,
    offset: pagination.offset.value,
    ...(term.value && { term: term.value }),
  });

  isLoading.value = false;
};

const onPageRefresh = async () => {
  pagination.resetPage();
  await fetchData({ reset: true, useLoading: true });
};

const onFullyScrolled = async () => {
  isPaginationLoading.value = true;

  pagination.nextPage();
  await fetchData({ reset: false, useLoading: false });

  isPaginationLoading.value = false;
};

watch(term, () => {
  fetchData({ reset: true, useLoading: true });
  pagination.resetPage();
});

onMounted(() => fetchData({ reset: true, useLoading: true }));
</script>